%{?scl:%scl_package xmlrpc}
%{!?scl:%global pkg_name %{name}}

Name:       %{?scl_prefix}xmlrpc
Version:    3.1.3
Release:    6%{?dist}
Epoch:      1
Summary:    Java XML-RPC implementation
License:    ASL 2.0
Group:      Development/Libraries
URL:        http://ws.apache.org/xmlrpc/
Source0:    http://www.apache.org/dist/ws/xmlrpc/sources/apache-xmlrpc-%{version}-src.tar.bz2
Source1:    %{pkg_name}-jpp-depmap.xml
# Add OSGi MANIFEST information
Patch0:     %{pkg_name}-client-addosgimanifest.patch
Patch1:     %{pkg_name}-common-addosgimanifest.patch
Patch2:     %{pkg_name}-javax-methods.patch

BuildRequires:  maven
BuildRequires:  maven-resources-plugin
BuildRequires:  maven-compiler-plugin
BuildRequires:  maven-surefire-plugin
BuildRequires:  maven-jar-plugin
BuildRequires:  maven-install-plugin
BuildRequires:  maven-javadoc-plugin
BuildRequires:  maven-assembly-plugin
BuildRequires:  maven-source-plugin
BuildRequires:  maven-site-plugin
BuildRequires:  ws-jaxme
BuildRequires:  %{?scl_prefix}ws-commons-util
BuildRequires:  jpackage-utils >= 0:1.6
BuildRequires:  %{?scl_prefix}tomcat-servlet-3.0-api
BuildRequires:  %{?scl_prefix}junit4
BuildRequires:  jakarta-commons-httpclient
BuildRequires:  %{?scl_prefix}apache-commons-logging

BuildArch:    noarch

%description
Apache XML-RPC is a Java implementation of XML-RPC, a popular protocol
that uses XML over HTTP to implement remote procedure calls.
Apache XML-RPC was previously known as Helma XML-RPC. If you have code
using the Helma library, all you should have to do is change the import
statements in your code from helma.xmlrpc.* to org.apache.xmlrpc.*.

%package javadoc
Summary:    Javadoc for %{pkg_name}
Group:      Documentation

%description javadoc
Javadoc for %{pkg_name}.

%package common
Summary:    Common classes for XML-RPC client and server implementations
Group:      Development/Libraries
# Provide xmlrpc is not here because it would be useless due to different jar names
Obsoletes:  %{name} < 3.1.3
Obsoletes:  %{name}3-common < 3.1.3-13
Provides:   %{name}3-common = 3.1.3-13
Requires:   ws-jaxme
Requires:   %{?scl_prefix}ws-commons-util
Requires:   jpackage-utils >= 0:1.6
Requires:   %{?scl_prefix}apache-commons-logging
%{?scl:Requires: %scl_runtime}

%description common
%{summary}.

%package client
Summary:    XML-RPC client implementation
Group:      Development/Libraries
Requires:   %{name}-common
Requires:   jakarta-commons-httpclient
Obsoletes:  %{name}3-client < 3.1.3-13
Provides:  %{name}3-client = 3.1.3-13

%description client
%{summary}.

%package server
Summary:    XML-RPC server implementation
Group:      Development/Libraries
Requires:   %{name}-client
Requires:   junit
Requires:   %{?scl_prefix}tomcat-servlet-3.0-api
Obsoletes:  %{name}3-server < 3.1.3-13
Provides:  %{name}3-server = 3.1.3-13

%description server
%{summary}.

%prep
%setup -q -n apache-%{pkg_name}-%{version}-src
%patch2 -b .sav
pushd client
%patch0 -b .sav
popd
pushd common
%patch1 -b .sav
popd

sed -i 's/\r//' LICENSE.txt

%build
%{?scl:%scl_maven_opts}
# ignore test failure because server part needs network
mvn-rpmbuild \
  -e \
  -Dmaven.local.depmap.file=%{SOURCE1} \
  -Dmaven.test.failure.ignore=true \
  install javadoc:aggregate

%install
# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}
install -m 644 client/target/%{pkg_name}-client-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{pkg_name}-client.jar
install -m 644 server/target/%{pkg_name}-server-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{pkg_name}-server.jar
install -m 644 common/target/%{pkg_name}-common-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{pkg_name}-common.jar

#compat symlinks remove in F-20
pushd $RPM_BUILD_ROOT%{_javadir}
ln -s %{pkg_name}-client.jar %{pkg_name}3-client.jar
ln -s %{pkg_name}-server.jar %{pkg_name}3-server.jar
ln -s %{pkg_name}-common.jar %{pkg_name}3-common.jar
popd

# install maven pom files
install -Dm 644 pom.xml $RPM_BUILD_ROOT%{_mavenpomdir}/JPP-%{pkg_name}.pom
install -Dm 644 common/pom.xml $RPM_BUILD_ROOT%{_mavenpomdir}/JPP-%{pkg_name}-common.pom
install -Dm 644 client/pom.xml $RPM_BUILD_ROOT%{_mavenpomdir}/JPP-%{pkg_name}-client.pom
install -Dm 644 server/pom.xml $RPM_BUILD_ROOT%{_mavenpomdir}/JPP-%{pkg_name}-server.pom

# ... and maven depmaps
%add_maven_depmap JPP-%{pkg_name}.pom
%add_maven_depmap JPP-%{pkg_name}-common.pom %{pkg_name}-common.jar
%add_maven_depmap JPP-%{pkg_name}-client.pom %{pkg_name}-client.jar
%add_maven_depmap JPP-%{pkg_name}-server.pom %{pkg_name}-server.jar

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{pkg_name}
cp -pr target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{pkg_name}

%files javadoc
%doc LICENSE.txt NOTICE.txt
%{_javadocdir}/*

%files common
%doc LICENSE.txt NOTICE.txt
%{_mavenpomdir}/JPP-%{pkg_name}.pom
%{_mavenpomdir}/JPP-%{pkg_name}-common.pom
%{_mavendepmapfragdir}/%{name}
%{_javadir}/%{pkg_name}-common.jar
%{_javadir}/%{pkg_name}3-common.jar

%files client
%{_mavenpomdir}/JPP-%{pkg_name}-client.pom
%{_javadir}/%{pkg_name}-client.jar
%{_javadir}/%{pkg_name}3-client.jar

%files server
%{_mavenpomdir}/JPP-%{pkg_name}-server.pom
%{_javadir}/%{pkg_name}-server.jar
%{_javadir}/%{pkg_name}3-server.jar

%changelog
* Thu Mar 21 2013 Krzysztof Daniel <kdaniel@redhat.com> 1:3.1.3-6
- Fix broken Require in server subpackage.

* Tue Feb 19 2013 Krzysztof Daniel <kdaniel@redhat.com> 1:3.1.3-5
- Fix provides/obsolete clauses.

* Mon Feb 18 2013 Krzysztof Daniel <kdaniel@redhat.com> 1:3.1.3-4
- Fix the require clauses.

* Mon Feb 18 2013 Krzysztof Daniel <kdaniel@redhat.com> 1:3.1.3-3
- Initial contribution to SCL.

* Sat Oct 20 2012 Peter Robinson <pbrobinson@fedoraproject.org>	3.1.3-2
- xmlrpc v2 had an Epoch so we need one here. Add it back

* Fri Sep 14 2012 Alexander Kurtakov <akurtako@redhat.com> 3.1.3-1
- First release of version 3.x package
